#include "descriptor/descriptor.h"
#include <stdio.h>

/*	
 *	Progetto di grafica di Francesco Chiarello - chiarelf@cs.unibo.it
 *	
 *	Script per creazione animazione e scena
*/	



int main(void) {
	
	// ELEMENTI

	ITEM scene;
	
	ITEM Luce1,Luce2,Luce3,Luce4,Luce5,Luce6;

	ITEM scrat, scrat_naso, scrat_denti, scrat_viso, scrat_occhio_dx, scrat_occhio_sx, scrat_globo_oculare_sx, scrat_globo_oculare_dx, scrat_orecchi, scrat_corpo, scrat_coda, scrat_arti, scrat_diti;
	
	ITEM ghianda, ghianda_corpo, ghianda_cappello, ghianda_gambo;
	
	ITEM finestra, infissi, infissi_interni, finestra_vetro, finestra_maniglia, cardine1, cardine2, cardine3, cardine4;
	
	ITEM tavolino, tavolino_struttura, tavolino_marmo, tav_piano, tav_piede1, tav_piede2, tav_piede_sotto;

	ITEM foto;

	ITEM tavolino_basso;

	ITEM cornice, poster, quadro;

	ITEM frigorifero, frigorifero_struttura, frigorifero_sotto, frigorifero_sopra, frigorifero_sinistra, frigorifero_destra, frigorifero_dietro, frigorifero_manici_superiori, frigorifero_manici_inferiori, frigorifero_barra_sopra, frigorifero_etichetta, frigorifero_scomparto_basso, frigorifero_scomparto_alto, frigorifero_scomparto_alto_parete, frigorifero_cardini;

	ITEM lampadario, lampadario_base, lampadario_filo, lampadario_lampada, lampadario_asta, lampadario_portalampada_base, lampadario_portalampada, lampadario_presa_muro, lampadario_presa_filo;

	ITEM lampada_rossa, lampada_rossa_base, lampada_rossa_asta, lampada_rossa_cappello;
	
	ITEM faretti, barra_faretti, sostegno_faretto1, sostegno_faretto2, faretto1,faretto2, faretto_metal, faretto_light, faretto_metal2, faretto_light2;
	
	ITEM stanza, parete_ant, parete_dx, parete_post, parete_sx, parete_sx2, parete_sx3, parete_sx4, pavimento, soffitto;
	
	// ATTRIBUTI
	ITEM tela_bianca, intonaco, granito, piastrelle, rosso, rosso_vivo, rosso_vivo_reflected, nero, marrone, marrone_pelo, nero_opaco, bianco, bianco_frigo, grigio_frigo, grigio, marmo, lucido_foto, cromatura, cromatura_scura, metallo, legno, legno_dorato, vetro_trasparente;


	// LUCI
	set_background(0.275,0.355,0.453,TRUE);
	set_ambient_light(0.9,0.9,0.9,1.7);
		
		// Luce lampada di destra (Temp. Colore verso il rosso)
		// Promemoria: int:3.2, dist:23 - colore: 1,0.93,0.90
	Luce2 = create_point_light(-17.2, -7.3, 9.2,  1,0.89,0.78,1.7,22, "Luce2");
	Luce3 = create_point_light(-16.7, -8.2, 5.0,  1,0.89,0.78,1.7,22, "Luce3");

	Luce1 = create_point_light(-8.800, 8.50, 0.963,  1,0.79,0.68,2.7,12, "Luce1");
	Luce6 = create_point_light(-8.800, 8.50, 0.600,  1,0.79,0.68,2.7,8, "Luce6");
		// Luce faretto1 verso il quadro (Temp. Colore blu)
	Luce4 = create_warn_light(-8.0,8.5,10.0, 3.20, 9.9,-11.0, 0.99,0.99,1, 2.4,25,0,33.0,0,0.0,0.0,0.0,0.0, "Luce4");
		// Luce faretto2 verso la ghianda e scrat (Temp. Colore blu)
	Luce5 = create_warn_light(-9.0,8.5,10.0, -9.0,-2.04, -4.6, 0.99,0.99,1, 4.4,40,0,8.0,0,0.0,0.0,0.0,0.0, "Luce5"); /* (cx, cy, cz, dx, dy, dx, r, g, b, intensity, range, concentration, maximum_angle, flap, name) */
	//Luce5 = create_warn_light(-9.0,8.5,10.0, -9.0,-2.04, -4.0, 0.99,0.99,1, 4.4,40,0,8.0,0,0.0,0.0,0.0,0.0, "Luce5"); /* (cx, cy, cz, dx, dy, dx, r, g, b, intensity, range, concentration, maximum_angle, flap, name) */

	
		// ATTRIBUTO Tela Bianca
	tela_bianca = create_attribute("tela_bianca");
	set_color(tela_bianca,0.5,0.5,0.5,0.9,0.8);
	set_reflectivity(tela_bianca,0,1);
	set_transparency(tela_bianca, 0.3, 0.2, 0.0, 8);
	
		// ATTRIBUTO Marmo
	marmo = create_attribute("marmo");
	set_color(marmo,0.6,0.6,0.65,0.3,0.5);
	set_reflectivity(marmo,0.07,1);
	set_transparency(marmo, 0.3, 0.1, 0.1, 1);
	
		// ATTRIBUTO Intonaco
	intonaco = create_attribute("intonaco");
	set_color(intonaco,1,1,1,0.1,0.7);
	set_reflectivity(intonaco,0.01,12);
	
		// ATTRIBUTO Piastrelle
	piastrelle = create_attribute("piastrelle");
	set_color(piastrelle,1,1,1,0.1,0.7);
	set_reflectivity(piastrelle,0.001,12);
	
		// ATTRIBUTO Granito
	granito = create_attribute("granito");
	set_color(granito,1,1,1,0.1,0.7);
	set_reflectivity(granito,0.08,1);
		
		// ATTRIBUTO Rosso
	rosso = create_attribute("rosso");
	set_color(rosso,0.6,0.1,0.1,0.05,0.3);
	set_reflectivity(rosso,0.2,10);

		// ATTRIBUTO Rosso Vivo
	rosso_vivo = create_attribute("rosso_vivo");
	set_color(rosso_vivo,1.0,0.0,0.0,0.05,0.3);
	set_reflectivity(rosso_vivo,0.04,1);
	set_transparency(rosso_vivo, 0.2, 0.06, 0.001, 2);

		// ATTRIBUTO Rosso Vivo Riflesso
	rosso_vivo_reflected = create_attribute("rosso_vivo_reflected");
	set_color(rosso_vivo_reflected,1.0,0.0,0.0,0.28,0.49);
	set_reflectivity(rosso_vivo_reflected,0.04,1);
	set_transparency(rosso_vivo_reflected, 0.2, 0.06, 0.001, 2);

		// ATTRIBUTO Nero
	nero = create_attribute("nero");
	set_color(nero,0,0,0,0.1,0.3);
	set_reflectivity(nero,0.3,5);

		// ATTRIBUTO Nero Opaco
	nero_opaco = create_attribute("nero_opaco");
	set_color(nero_opaco,0,0,0,0.1,0.3);
	set_reflectivity(nero_opaco,0.09,1);
	
		// ATTRIBUTO Marrone
	marrone = create_attribute("marrone");
	set_color(marrone,0.80,0.43,0.15,0.20,0.20);
	set_reflectivity(marrone,0.10,1);

		// ATTRIBUTO Marrone Pelo
	marrone_pelo = create_attribute("marrone_pelo");
	set_color(marrone_pelo,0.87,0.67,0.48,0.20,0.20);
	set_reflectivity(marrone_pelo,0.01,1);

		// ATTRIBUTO Grigio
	grigio = create_attribute("grigio");
	set_color(grigio,0.20,0.24,0.20,0.24,0.20);
	set_reflectivity(grigio,0.15,30);

		// ATTRIBUTO Bianco
	bianco = create_attribute("bianco");
	set_color(bianco,1.0,1.0,1.0,0.3,0.0);
	set_reflectivity(bianco,0.0,0.0);

		// ATTRIBUTO Bianco Frigo
	bianco_frigo = create_attribute("bianco_frigo");
	set_color(bianco_frigo,0.65,0.65,0.65,0.2,0.45);
	set_reflectivity(bianco_frigo,0.02,100);

		// ATTRIBUTO Grigio Frigo
	grigio_frigo = create_attribute("grigio_frigo");
	set_color(grigio_frigo,0.50,0.50,0.50,0.2,0.45);
	set_reflectivity(grigio_frigo,0.04,1);
	
		// ATTRIBUTO Cromatura
	cromatura = create_attribute("cromatura");
	set_color(cromatura,0.3,0.3,0.3,0.2,0.2);
	set_reflectivity(cromatura,0.9,20);	// quantita' riflessione [0,1], riflesso bianco (meno a valori alti)

		// ATTRIBUTO Cromatura scura
	cromatura_scura = create_attribute("cromatura_scura");
	set_color(cromatura_scura,0.15,0.15,0.15,0.15,0.15);
	set_reflectivity(cromatura_scura,0.8,20);

		// ATTRIBUTE Vetro trasparente
	vetro_trasparente = create_attribute("vetro_trasparente");
	set_color(vetro_trasparente,0.68,0.86,1,0.5,0.5);
	//set_reflectivity(vetro_trasparente,0.24,2);
	set_transparency(vetro_trasparente,1,1,10000,1.89);
			
		// ATTRIBUTO Metallo
	metallo = create_attribute("metallo");
	set_color(metallo,0.15,0.15,0.15,0.41,0.90);
	set_reflectivity(metallo,0.8,20);

		// ATTRIBUTO Lucido foto
	lucido_foto = create_attribute("lucido_foto");
	set_color(lucido_foto,1,1,1,0.2,1);
	set_reflectivity(lucido_foto,0.1,4);
		
		// ATTRIBUTO Legno
	legno = create_attribute("legno");
	set_color(legno,0.4,0.3,0.1,0.2,0.3);
	set_reflectivity(legno,0.05,1.5);
	
		// ATTRIBUTO Legno dorato
	legno_dorato = create_attribute("legno_dorato");
	set_color(legno_dorato,0.6,0.5,0.2,0.1,0.3);
	set_reflectivity(legno_dorato,0.25,1.5);

	/* RESTO DELLA STANZA */
	
		// FINESTRA
	infissi = read_nurbs("infissi.db");
	infissi_interni = read_nurbs("infissi_interni.db");
	finestra_vetro = read_nurbs("finestra_vetro.db");
	cardine1 = read_nurbs("finestra_cardine1.db");
	cardine2 = read_nurbs("finestra_cardine2.db");
	cardine3 = read_nurbs("finestra_cardine3.db");
	cardine4 = read_nurbs("finestra_cardine4.db");
	finestra_maniglia = read_obj("finestra_maniglia.obj", "finestra_maniglia");

	set_attribute(infissi, legno);
	set_attribute(infissi_interni, legno);
	set_domain_texture(infissi, legno, "textures/noce.hr",0,0.6,0,0.6,1,0.3,0.4);
	set_domain_texture(infissi_interni, legno, "textures/noce.hr",0,0.6,0,0.6,1,0.3,0.4);
	set_attribute(finestra_vetro, vetro_trasparente);
	set_attribute(finestra_maniglia, nero);
	set_attribute(cardine1, nero);
	set_attribute(cardine2, nero);
	set_attribute(cardine3, nero);
	set_attribute(cardine4, nero);
	
	finestra = create_list(infissi, "finestra");
	finestra = insert_in_list(finestra, infissi_interni);
	finestra = insert_in_list(finestra, finestra_vetro);
	finestra = insert_in_list(finestra, finestra_maniglia);
	finestra = insert_in_list(finestra, cardine1);
	finestra = insert_in_list(finestra, cardine2);
	finestra = insert_in_list(finestra, cardine3);
	finestra = insert_in_list(finestra, cardine4);
	set_z_rotate(finestra, 90, 1);
	set_translate(finestra, -14.82, -27.9, 20.3);
	set_scale(finestra, 0.35,0.35,0.3);
	
	
			// LAMPADARIO
	
	lampadario_base = read_nurbs("lampadario_base.db");
	lampadario_asta = read_nurbs("lampadario_asta.db");
	lampadario_lampada = read_nurbs("lampadario_lampada.db");
	lampadario_filo = read_nurbs("lampadario_filo.db");
	lampadario_portalampada_base = read_nurbs("lampadario_portalampada_base.db");
	lampadario_portalampada = read_nurbs("lampadario_portalampada.db");
	lampadario_presa_muro = read_nurbs("lampadario_presa_muro.db");
	lampadario_presa_filo = read_nurbs("lampadario_presa_filo.db");

	set_attribute(lampadario_base, nero);
	set_attribute(lampadario_asta, grigio);
	set_attribute(lampadario_lampada, tela_bianca);
	set_attribute(lampadario_filo, nero);
	set_attribute(lampadario_portalampada, grigio);
	set_attribute(lampadario_portalampada_base, grigio);
	set_attribute(lampadario_presa_muro, bianco);
	set_attribute(lampadario_presa_filo, bianco);

	lampadario = create_list(lampadario_base, "lampadario");
	lampadario = insert_in_list(lampadario, lampadario_asta);
	lampadario = insert_in_list(lampadario, lampadario_lampada);
	lampadario = insert_in_list(lampadario, lampadario_filo);
	lampadario = insert_in_list(lampadario, lampadario_portalampada);
	lampadario = insert_in_list(lampadario, lampadario_portalampada_base);
	lampadario = insert_in_list(lampadario, lampadario_presa_muro);
	lampadario = insert_in_list(lampadario, lampadario_presa_filo);

	set_z_rotate(lampadario, 320, 1);
	set_translate(lampadario, -3.7, -1.59, 0.43);
	set_scale(lampadario, 4.7,4.7,4.7);

			// QUADRO
	cornice = read_obj("cornice.obj", "cornice");
	set_attribute(cornice, legno_dorato);
	poster = read_nurbs("poster.db");
	set_attribute(poster, intonaco);
	set_domain_texture(poster, intonaco, "textures/ghianda.hr",0,1,0,1,0,0.3,0.4);
	
	quadro = create_list(cornice, "quadro");
	quadro = insert_in_list(quadro, poster);
	set_z_rotate(quadro, 270, 1);
	set_translate(quadro, -25, 28.4, 20);
	set_scale(quadro, 0.35,0.35,0.3);
	
	
			// TAVOLINO centrale
	
	tavolino_struttura = read_obj("tavolino.obj", "tavolino_struttura");
	set_attribute(tavolino_struttura, legno);
	tavolino_marmo = read_nurbs("tavolino_piano_marmo.db");
	set_y_rotate(tavolino_marmo, 90, 1);	// trasformazioni per effetto lastra marmo
	set_z_rotate(tavolino_marmo, -26, 1);
	set_x_rotate(tavolino_marmo, 6, 1);
	set_projection_texture(tavolino_marmo, marmo, "textures/marmo_rosa.hr",0,1,0.3,0.4);
	set_x_rotate(tavolino_marmo, -6, 1);	// trasformazioni inverse
	set_z_rotate(tavolino_marmo, 26, 1);
	set_y_rotate(tavolino_marmo, -90, 1);
	set_attribute(tavolino_struttura, legno);
	set_domain_texture(tavolino_struttura, legno, "textures/legno.hr",0,1.2,0,1.2,1,0.3,0.4);
	tavolino = create_list(tavolino_struttura, "tavolino_struttura");
	tavolino = insert_in_list(tavolino, tavolino_marmo);
	set_translate(tavolino, -7.3, 0.12, 0.57);
	set_scale(tavolino, 2.4,2.4,2.4);
	
			// TAVOLINO BASSO
	tavolino_basso = read_obj("tavolino_basso.obj", "tavolino_basso");
	set_scale(tavolino_basso, 4.9, 4.9, 4.9);
	set_translate(tavolino_basso, 8.2, 8.6, -0.40);
	set_z_rotate(tavolino_basso, 90, 1);
	set_attribute(tavolino_basso, legno);
	set_domain_texture(tavolino_basso, legno, "textures/legno.hr",0,1.2,0,1.2,1,0.3,0.4);
	
			// LAMPADA ROSSA
	lampada_rossa_base = read_nurbs("lampada_rossa_base.db");
	set_attribute(lampada_rossa_base, rosso_vivo);
	lampada_rossa_asta = read_nurbs("lampada_rossa_asta.db");
	set_attribute(lampada_rossa_asta, rosso_vivo);
	lampada_rossa_cappello = read_nurbs("lampada_rossa_cappello.db");
	set_attribute(lampada_rossa_cappello, rosso_vivo_reflected);
	lampada_rossa = create_list(lampada_rossa_base, "lampada_rossa");
	lampada_rossa = insert_in_list(lampada_rossa, lampada_rossa_asta);
	lampada_rossa = insert_in_list(lampada_rossa, lampada_rossa_cappello);
	set_scale(lampada_rossa, 4.9, 4.9, 4.9);
	set_translate(lampada_rossa, -8.7, 8.4, 0.13);


			// FOTO
	foto = read_nurbs("foto.db");
	set_x_rotate(foto,90,1);
	set_translate(foto,-0.5,0,-0.1);
	set_projection_texture(foto, lucido_foto, "textures/foto.hr",1,1,0.4,0.9);
	//set_x_rotate(foto,-90,1);
	set_y_rotate(foto, -20, 1);
	set_scale(foto,0.5,1.2,0.5);
	set_z_rotate(foto, 175, 1);
	set_translate(foto,-15.49,7.77,6.15);

			// FRIGORIFERO
	frigorifero_struttura = read_obj("frigorifero_struttura.obj", "frigorifero_struttura_solida");

	//frigorifero_struttura = read_nurbs("frigorifero.dbe");
	set_attribute(frigorifero_struttura, bianco_frigo);
	frigorifero_manici_superiori = read_obj("frigorifero_manici_superiori.obj", "frigorifero_manici_superiori");
	set_attribute(frigorifero_manici_superiori, grigio_frigo);
	frigorifero_manici_inferiori = read_obj("frigorifero_manici_inferiori.obj", "frigorifero_manici_inferiori");
	set_attribute(frigorifero_manici_inferiori, grigio_frigo);
	frigorifero_etichetta = read_nurbs("frigorifero_etichetta.db");
	set_attribute(frigorifero_etichetta, grigio_frigo);
	set_domain_texture(frigorifero_etichetta, grigio_frigo, "textures/iberna.hr",0,1,0,1,0,0.3,0.4);
	frigorifero_barra_sopra = read_nurbs("frigorifero_barra_sopra.db");
	set_attribute(frigorifero_barra_sopra, bianco_frigo);

	frigorifero_scomparto_basso = read_nurbs("frigorifero_scomparto_basso.db");
	set_attribute(frigorifero_scomparto_basso, bianco_frigo);
	frigorifero_scomparto_alto_parete = read_nurbs("frigorifero_scomparto_alto.db");
	set_attribute(frigorifero_scomparto_alto_parete, bianco_frigo);
	frigorifero_scomparto_alto = create_list(frigorifero_scomparto_alto_parete, "frigorifero_scomparto_alto");
	frigorifero_scomparto_alto = insert_in_list(frigorifero_scomparto_alto, frigorifero_manici_superiori);
	//set_z_rotate(frigorifero_scomparto_alto, 100, 1);
	set_z_rotate(frigorifero_scomparto_alto, 85, 1);
	set_translate(frigorifero_scomparto_alto, 0.507, -0.038, 0.0);

	frigorifero_cardini = read_obj("frigorifero_cardini.obj", "frigorifero_cardini");
	set_attribute(frigorifero_cardini, metallo);
	
	frigorifero = create_list(frigorifero_struttura, "frigorifero");
	frigorifero = insert_in_list(frigorifero, frigorifero_barra_sopra);
	frigorifero = insert_in_list(frigorifero, frigorifero_etichetta);
	frigorifero = insert_in_list(frigorifero, frigorifero_scomparto_basso);
	frigorifero = insert_in_list(frigorifero, frigorifero_scomparto_alto);
	frigorifero = insert_in_list(frigorifero, frigorifero_cardini);
	
	set_translate(frigorifero, -3.01, 1.00, 0.333);
	set_scale(frigorifero, 6.35,6.35,6.35);
			
			// Faretto di illuminazione finestra e faretto illuminazione scrat
	
	faretto_metal = read_obj("faretto_acciaio.obj", "faretto_metal");
	faretto_metal2 = read_obj("faretto_acciaio.obj", "faretto_metal2");
	set_attribute(faretto_metal, cromatura);	set_attribute(faretto_metal2, cromatura);
	set_scale(faretto_metal, 0.22, 0.22, 0.22);	set_scale(faretto_metal2, 0.22, 0.22, 0.22);
	faretto_light = read_nurbs("faretto_luce.db");	faretto_light2 = read_nurbs("faretto_luce.db");
	set_attribute(faretto_light, tela_bianca);	set_attribute(faretto_light2, tela_bianca);
	set_scale(faretto_light, 0.22, 0.22, 0.22);	set_scale(faretto_light2, 0.22, 0.22, 0.22);
	
	faretto1 = create_list(faretto_metal, "faretto1");
	faretto1 = insert_in_list(faretto1, faretto_light);
	set_x_rotate(faretto1, 35, 1);
	set_y_rotate(faretto1, -15, 1);
	set_translate(faretto1, -7.9,8.0,10.5);
	
	faretto2 = create_list(faretto_metal2, "faretto2");
	faretto2 = insert_in_list(faretto2, faretto_light2);
	set_x_rotate(faretto2, -165, 1);
	set_y_rotate(faretto2, -130, 1);
	set_translate(faretto2, -10.9,7.8,10.6);
	
	
			// Struttura di sostegno faretti
	
	barra_faretti = read_obj("barra_faretti.obj", "barra_faretti");
	set_attribute(barra_faretti, cromatura_scura);
	set_scale(barra_faretti, 0.22, 0.22, 0.22);
	set_z_rotate(barra_faretti, 90,1);
	set_translate(barra_faretti, -9.4,7.85,11.55);
	sostegno_faretto1 = read_obj("faretto_sostegno.obj", "sostegno_faretto1");
	sostegno_faretto2 = read_obj("faretto_sostegno.obj", "sostegno_faretto2");
	set_attribute(sostegno_faretto1, cromatura);	set_attribute(sostegno_faretto2, cromatura);
	set_scale(sostegno_faretto1, 0.22, 0.22, 0.3);	set_scale(sostegno_faretto2, 0.22, 0.22, 0.3);
	set_z_rotate(sostegno_faretto1, 75, 1);
	set_translate(sostegno_faretto1, -8,7.85,10.35);
	set_z_rotate(sostegno_faretto2, -165, 1);
	set_translate(sostegno_faretto2, -10.7,7.85,10.35);
	
	
			// Faretti (lista struttura sostegno faretti e faretti)
	
	faretti = create_list(barra_faretti, "faretti");
	faretti = insert_in_list(faretto1, faretti);
	faretti = insert_in_list(sostegno_faretto1, faretti);
	faretti = insert_in_list(faretto2, faretti);
	faretti = insert_in_list(sostegno_faretto2, faretti);
	
	
			// Ghianda

	ghianda_corpo = read_nurbs("ghianda_corpo.db");
	set_attribute(ghianda_corpo, marrone);
	ghianda_cappello = read_nurbs("ghianda_cappello.db");
	set_attribute(ghianda_cappello, legno);
	set_projection_texture(ghianda_cappello, marrone, "textures/cappello_ghianda.hr",0,1,0.2,0.5);	// 0.2, 0.3
	ghianda_gambo = read_nurbs("ghianda_gambo.db");
	set_attribute(ghianda_gambo, legno);	
	set_domain_texture(ghianda_gambo, legno, "textures/legno.hr",0,0.6,0,0.6,1,0.3,0.4);
	
	ghianda = create_list(ghianda_corpo, "ghianda");
	ghianda = insert_in_list(ghianda, ghianda_cappello);
	ghianda = insert_in_list(ghianda, ghianda_gambo);
	set_y_rotate(ghianda, -30, 1);
	//set_x_rotate(ghianda, -30, 1);
	set_translate(ghianda, -32.85, 10.50, 10.85);
	set_scale(ghianda, 0.6, 0.6, 0.6);

			// SCRAT
			// Naso
	scrat_naso = read_nurbs("scrat_naso.db");
	set_attribute(scrat_naso, nero_opaco);
			// Viso
	scrat_viso = read_nurbs("scrat_viso.db");
	set_attribute(scrat_viso, marrone);
	set_domain_texture(scrat_viso, marrone, "textures/viso1.hr",0.0,0.1,0.0,1.0,1,0.455,0.0);	
			// Denti
	scrat_denti = read_obj("scrat_denti.obj", "scrat_denti");
	set_attribute(scrat_denti, bianco);
			// Occhi
	scrat_occhio_sx = read_nurbs("scrat_occhio_sx.dbe");
	set_attribute(scrat_occhio_sx, marrone);
	scrat_occhio_dx = read_nurbs("scrat_occhio_dx.dbe");
	set_attribute(scrat_occhio_dx, marrone);
	set_domain_texture(scrat_occhio_dx, marrone, "textures/viso1.hr",1.0,0.0,0.0,1.0,0,0.455,0.0);
	set_domain_texture(scrat_occhio_sx, marrone, "textures/viso1.hr",1.0,0.0,0.0,1.0,0,0.455,0.0);
			// Globi
	scrat_globo_oculare_dx = read_nurbs("scrat_globo_oculare_dx.db");
	set_attribute(scrat_globo_oculare_dx, bianco);
	set_domain_texture(scrat_globo_oculare_dx, bianco, "textures/pupilla.hr",0.3,0.65,0.1,0.35,0,0.455,0.0);
	scrat_globo_oculare_sx = read_nurbs("scrat_globo_oculare_sx.db");
	set_attribute(scrat_globo_oculare_sx, bianco);
	set_domain_texture(scrat_globo_oculare_sx, bianco, "textures/pupilla.hr",0.3,0.65,0.1,0.35,0,0.455,0.0);
			// Orecchi
	scrat_orecchi = read_obj("scrat_orecchi.obj", "scrat_orecchi");
	set_attribute(scrat_orecchi, marrone);
	set_domain_texture(scrat_orecchi, marrone, "textures/orecchi_scrat.hr",0.0,1.0,0.0,1.0,0,0.455,0.0);
			// Corpo
	scrat_corpo = read_nurbs("scrat_corpo.db");
	set_attribute(scrat_corpo, marrone);
	set_domain_texture(scrat_corpo, marrone, "textures/corpo.hr",0.0,1.0,0.0,0.2,1,0.455,0.10);
			// Coda
	scrat_coda = read_nurbs("scrat_coda.db");
	set_attribute(scrat_coda, marrone);
	set_domain_texture(scrat_coda, marrone, "textures/coda.hr",0.0,1.0,0.0,0.1,1,0.455,0.0);
			// Arti
	scrat_arti = read_obj("scrat_arti.obj", "scrat_arti");
	set_attribute(scrat_arti, marrone);
	set_domain_texture(scrat_arti, marrone, "textures/corpo.hr",0.0,1.0,0.0,0.10,1,0.455,0.0);
			// Dita (o diti?)
	scrat_diti = read_obj("scrat_diti.obj", "scrat_diti");
	set_attribute(scrat_diti, marrone);
	set_domain_texture(scrat_diti, marrone, "textures/diti_scrat.hr",0.0,1.0,0.0,1.0,1,0.455,0.0);
	
	scrat = create_list(scrat_naso, "scrat");
	scrat = insert_in_list(scrat, scrat_viso);
	scrat = insert_in_list(scrat, scrat_denti);
	scrat = insert_in_list(scrat, scrat_occhio_dx);
	scrat = insert_in_list(scrat, scrat_occhio_sx);
	scrat = insert_in_list(scrat, scrat_globo_oculare_dx);
	scrat = insert_in_list(scrat, scrat_globo_oculare_sx);
	scrat = insert_in_list(scrat, scrat_orecchi);
	scrat = insert_in_list(scrat, scrat_corpo);
	scrat = insert_in_list(scrat, scrat_coda);
	scrat = insert_in_list(scrat, scrat_arti);
	scrat = insert_in_list(scrat, scrat_diti);
	set_z_rotate(scrat, 210, 1);
	set_scale(scrat, 0.650, 0.650, 0.650);
	set_translate(scrat, -18.050, 6.150, 4.54);
	//set_translate(scrat, -14.550, 6.150, 4.75);

	// STANZA

	parete_dx = read_nurbs("murodx.db");
	parete_sx = read_nurbs("murosx.db");
	parete_sx2 = read_nurbs("murosx2.db");
	parete_sx3 = read_nurbs("murosx3.db");
	parete_sx4 = read_nurbs("murosx4.db");
	pavimento = read_nurbs("pav.db");
	parete_post = read_nurbs("muroback.db");
	parete_ant = read_nurbs("murofront.db");
	soffitto = read_nurbs("soffitto.db");

	set_attribute(parete_dx, piastrelle);
	set_z_rotate(parete_dx,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_dx,90,1);
	set_projection_texture(parete_dx, piastrelle, "textures/mattonella_quadrata.hr",0,1,0.2,0.5);	// 0.2, 0.3
	set_x_rotate(parete_dx,-90,1);	// trasformazione inversa
	set_z_rotate(parete_dx,-90,1);
	
	set_attribute(parete_sx, piastrelle);
	set_z_rotate(parete_sx,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_sx,90,1);
	set_projection_texture(parete_sx, piastrelle, "textures/mattonella_quadrata.hr",0,1,0.2,0.5);
	set_x_rotate(parete_sx,-90,1);	// trasformazione inversa
	set_z_rotate(parete_sx,-90,1);
	
	set_attribute(parete_sx2, piastrelle);
	set_z_rotate(parete_sx2,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_sx2,90,1);
	set_projection_texture(parete_sx2, piastrelle, "textures/mattonella_quadrata.hr",0,1,0.2,0.5);
	set_x_rotate(parete_sx2,-90,1);	// trasformazione inversa
	set_z_rotate(parete_sx2,-90,1);
	
	set_attribute(parete_sx3, piastrelle);
	set_z_rotate(parete_sx3,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_sx3,90,1);
	set_projection_texture(parete_sx3, piastrelle, "textures/mattonella_quadrata.hr",0,1,0.2,0.5);
	set_x_rotate(parete_sx3,-90,1);	// trasformazione inversa
	set_z_rotate(parete_sx3,-90,1);
	
	set_attribute(parete_sx4, piastrelle);
	set_z_rotate(parete_sx4,90,1);	// trasformazione di proiezione
	set_x_rotate(parete_sx4,90,1);
	set_projection_texture(parete_sx4, piastrelle, "textures/mattonella_quadrata.hr",0,1,0.2,0.5);
	set_x_rotate(parete_sx4,-90,1);	// trasformazione inversa
	set_z_rotate(parete_sx4,-90,1);
	
	set_attribute(parete_ant, piastrelle);
	set_domain_texture(parete_ant, piastrelle, "textures/mattonella_quadrata.hr",0,0.1,0,0.1,1,0.2,0.5);
	set_attribute(parete_post, piastrelle);

	set_domain_texture(parete_post, piastrelle, "textures/mattonella_quadrata.hr",0,0.1,0,0.1,1,0.2,0.5);

	set_attribute(soffitto, piastrelle);

	set_attribute(pavimento, granito);
	set_domain_texture(pavimento, granito, "textures/granito.hr",0,0.1,0,0.1,1,0.15,0.4);
	//set_domain_texture(pavimento, intonaco, "textures/pavimento1.hr",0,0.1,0,0.1,1,0.2,0.5);
	//set_bump_texture(pavimento, intonaco, "textures/pavimento1_bump.hr",0,0.1,0,0.1,1,0.2,0.3);	// non corretto

	stanza = create_list(pavimento, "stanza");
		stanza = insert_in_list(stanza,parete_sx);
		stanza = insert_in_list(stanza,parete_sx2);
		stanza = insert_in_list(stanza,parete_sx3);
		stanza = insert_in_list(stanza,parete_sx4);
		stanza = insert_in_list(stanza,parete_dx);
		stanza = insert_in_list(stanza,parete_ant);
		stanza = insert_in_list(stanza,parete_post);
		stanza = insert_in_list(stanza,soffitto);
	set_translate(stanza,0.0,0.0,0.005);

	// SCENA FINALE

	scene = create_list(stanza, "scena");

	scene = insert_in_list(scene, scrat);
	scene = insert_in_list(scene, ghianda);

	scene = insert_in_list(scene, finestra);
	scene = insert_in_list(scene, lampadario);
	scene = insert_in_list(scene, quadro);
	scene = insert_in_list(scene, tavolino);
	scene = insert_in_list(scene, tavolino_basso);
	scene = insert_in_list(scene, lampada_rossa);
	scene = insert_in_list(scene, foto);
	scene = insert_in_list(scene, frigorifero);
	scene = insert_in_list(scene, faretti);
	
	
	save_scene("scrat.md","scrat",scene);

	return(0);
}
